Index: squid/src/HintCacheNodes.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/Attic/HintCacheNodes.c,v
retrieving revision 1.1.2.1
retrieving revision 1.1.2.2
diff -u -r1.1.2.1 -r1.1.2.2
--- squid/src/HintCacheNodes.c	20 Nov 2001 06:54:24 -0000	1.1.2.1
+++ squid/src/HintCacheNodes.c	21 May 2002 02:46:41 -0000	1.1.2.2
@@ -1,7 +1,7 @@
 /*
- * $Date: 2001/11/20 06:54:24 $ $Id: HintCacheNodes.c,v 1.1.2.1 2001/11/20 06:54:24 jkay Exp $
+ * $Date: 2002/05/21 02:46:41 $ $Id: HintCacheNodes.c,v 1.1.2.2 2002/05/21 02:46:41 jkay Exp $
  *
- * DEBUG: section 60    List of known caches.
+ * DEBUG: section 88    List of known caches.
  * AUTHOR: Mike Dahlin, UT Austin, 1998
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -65,53 +65,57 @@
  * static void HCNodelist_OutcallJoin() _PARAMS((struct sockaddr_in sin));
  * e.g.  The nodelist promises to tell Plaxton when a new node joins.
  *
- * static void HCNodelist_OutcallLeave() _PARAMS((struct sockaddr_in sin));
+ * static void hintCacheNodelist_OutcallLeave() _PARAMS((struct sockaddr_in sin));
  *  The nodelist promises to tell Plaxton when a node leaves.
  */
 
-typedef struct HierNodeElem{
-  List_Links links;  /* MUST be first element of structure */
-  struct sockaddr_in sin;
-  int action; /* HC_Join or HC_Leave */
-  long long timestamp_ns; /* time of action */
-}HierNodeElem;
+#define HCNODES_DEBUG 88
 
-static List_Links nodes;
+typedef struct HierNodeElem
+{
+    dlink_node links;
+    struct sockaddr_in sin;
+    int action;			/* HC_Join or HC_Leave */
+    long long timestamp_ns;	/* time of action */
+}
+HierNodeElem;
+
+static dlink_list nodes;
 static int myStatus = HC_Leave;
 
 static void HierNodeElem_Init _PARAMS((HierNodeElem *, struct sockaddr_in *,
-				       int action, long long timestamp_ns));
+	int action, long long timestamp_ns));
 
 static HierNodeElem *nodeFind(struct sockaddr_in *sin);
 static long long currentTimeNS();
-static void floodEvent(int action, struct sockaddr_in *source, 
-		       long long timeNS, int hopcount);
+static void floodEvent(int action, struct sockaddr_in *source,
+    long long timeNS, int hopcount);
 
-static void HCNodelist_OutcallHops(struct sockaddr_in *sin, 
-				    int hops, long long timeNS);
-static void HCNodelist_OutcallJoin(struct sockaddr_in *sin, 
-				    int hops, long long timeNS);
-static void HCNodelist_OutcallLeave(struct sockaddr_in *sin, 
-				    int hops, long long timeNS);
+static void hintCacheNodelistOutcallHops(struct sockaddr_in *sin,
+    int hops, long long timeNS);
+static void hintCacheNodelistOutcallJoin(struct sockaddr_in *sin,
+    int hops, long long timeNS);
+static void hintCacheNodelistOutcallLeave(struct sockaddr_in *sin,
+    int hops, long long timeNS);
 
 static void printList();
 
 
 static void
-HierNodeElem_Init(HierNodeElem *e, struct sockaddr_in *sin, int action,
-		  long long timestamp_ns)
+HierNodeElem_Init(HierNodeElem * e, struct sockaddr_in *sin, int action,
+    long long timestamp_ns)
 {
-  assert(action == HC_Join || action == HC_Leave);
-  List_InitElement(&e->links);
-  e->sin = *sin;
-  e->action = action;
-  e->timestamp_ns = timestamp_ns;
+    assert(action == HC_Join || action == HC_Leave);
+    List_InitElement(&e->links);
+    e->sin = *sin;
+    e->action = action;
+    e->timestamp_ns = timestamp_ns;
 }
 
 /*
  *------------------------------------------------------------------
  *
- * HCNodeList_Init --
+ * hintCacheNodeList_Init --
  *
  *          Constructor.
  *
@@ -126,16 +130,16 @@
  *
  *----------------------------------------------3.31.1998-------------
  */
-void 
-HCNodelist_Init (void)
+void
+hintCacheNodelistInit(void)
 {
-  List_Init(&nodes);
+    nodes.head = nodes.tail = 0;
 }
 
 /*
  *------------------------------------------------------------------
  *
- * HCNodeList_Destroy --
+ * hintCacheNodeListDestroy --
  *
  *          Deallocate all elements in list
  *
@@ -150,22 +154,23 @@
  *
  *--------------------------------------------------3.31.1998-------
  */
-void 
-HCNodelist_Destroy (void)
+void
+hintCacheNodelist_Destroy(void)
 {
-  List_Links *item;
-  while(!List_IsEmpty(&nodes)){
-    item = List_First(&nodes);
-    List_Remove(item);
-    free(item);
-  }
+    dlink_node *item;
+    
+    while (nodes.head) {
+	item = nodes.head;
+	dlinkDelete(item, &nodes);
+	xfree(item);
+    }
 }
 
 
 /*
  *------------------------------------------------------------------
  *
- * HCNodeList_LocalJoin --
+ * hintCacheNodeListLocalJoin --
  *
  *          Do a local join. This tells the algorithm
  *          to flood "join" messages to the neighbors.
@@ -181,45 +186,45 @@
  *
  *-----------------------------------------------------4.1.1998----
  */
-void 
-HCNodelist_LocalJoin(void)
+void
+hintCacheNodelistLocalJoin(void)
 {
-  struct sockaddr_in *myId;
-  int hopcount;
-  long long timeNS;
+    struct sockaddr_in *myId;
+    int hopcount;
+    long long timeNS;
 #if 0
-  HCEntry hcEntry;
-  HCUpdate update;
-  URLKey key;
-  int nbpl;
-  int ii;
+    HintCacheEntry hcEntry;
+    HintCacheUpdate update;
+    URLKey key;
+    int nbpl;
+    int ii;
 #endif
 
-  myStatus = HC_Join;
+    myStatus = HC_Join;
 
-  myId = &Config.Sockaddr.http->s;
-  timeNS = currentTimeNS();
-  hopcount = 1;
-  floodEvent(HC_Join, myId, timeNS, hopcount);
+    myId = &Config.Sockaddr.http->s;
+    timeNS = currentTimeNS();
+    hopcount = 1;
+    floodEvent(HC_Join, myId, timeNS, hopcount);
 
 #if 0
-  /* "Priming" code */
-  if (parentOutgoingA) {
-      nbpl = (HCPlax_bucketsPerLevel > 0) ? HCPlax_bucketsPerLevel : 256;
-      for(ii = 0; ii < nbpl; ii++) {
-	  key.key = ii;
-	  HCEntry_Init(&hcEntry, key, &Config.Sockaddr.http->s;
-	  HCUpdate_Init(&update, HC_InvalToParent, &hcEntry, 1);
-	  hcprop_handleInvalToParent(&update, 1);
-      }
-  }
+    /* "Priming" code */
+    if (parentOutgoingA) {
+	nbpl = (hintCachePlax_bucketsPerLevel > 0) ? hintCachePlax_bucketsPerLevel : 256;
+	for (ii = 0; ii < nbpl; ii++) {
+	    key.key = ii;
+	    hintCacheEntry_Init(&hcEntry, key, &Config.Sockaddr.http->s);
+	    hintCacheUpdate_Init(&update, HC_InvalToParent, &hcEntry, 1);
+	    hcprop_handleInvalToParent(&update, 1);
+	}
+    }
 #endif
 }
 
 /*
  *------------------------------------------------------------------
  *
- * HCNodeList_LocalLeave --
+ * hintCacheNodeListLocalLeave --
  *
  *          Do a local leave. This tells the algorithm
  *          to flood "leave" messages to the neighbors.
@@ -235,25 +240,25 @@
  *
  *-----------------------------------------------------4.1.1998----
  */
-void 
-HCNodelist_LocalLeave(void)
+void
+hintCacheNodelistLocalLeave(void)
 {
-  struct sockaddr_in *myId;
-  int hopcount;
-  long long timeNS;
-
-  myStatus = HC_Leave;
-  myId = &Config.Sockaddr.http->s;
-  timeNS = currentTimeNS();
-  hopcount = 1;
-  floodEvent(HC_Leave, myId, timeNS, hopcount);
+    struct sockaddr_in *myId;
+    int hopcount;
+    long long timeNS;
+
+    myStatus = HC_Leave;
+    myId = &Config.Sockaddr.http->s;
+    timeNS = currentTimeNS();
+    hopcount = 1;
+    floodEvent(HC_Leave, myId, timeNS, hopcount);
 }
 
 
 /*
  *------------------------------------------------------------------
  *
- * HCNodeList_getMyStatus --
+ * hintCacheNodelistgetMyStatus --
  *
  *          Am I currently in or out?
  *
@@ -269,16 +274,16 @@
  *----------------------------------------------------4.1.1998--------
  */
 int
-HCNodelist_myStatus(void)
+hintCacheNodelistmyStatus(void)
 {
-  return myStatus;
+    return myStatus;
 }
 
 
 /*
  *------------------------------------------------------------------
  *
- * HCNodeList_NetJoin --
+ * hintCacheNodelistNetJoin --
  *
  *          Process a "join" received from the network.
  *          If this is a new node, a new action for a node,
@@ -298,101 +303,99 @@
  *
  *------------------------------------------------------7.19.1998----
  */
-void 
-HCNodelist_NetJoin(struct sockaddr_in *sin, int hops, long long joinTimeNS)
+void
+hintCacheNodelistNetJoin(struct sockaddr_in *sin, int hops, long long joinTimeNS)
 {
-  HierNodeElem *h, *oldCopy;
-  int oldHops;
-  int foundOldJoin = 0;
-  int joinIsNewer;
-
-  assert(sin);
-  /* Ignore if it's already on list and either (1) a newer record
-   * or (2) a current record and at least as close as this
-   * update.  Also ignore if it is me!
-   * For simplicity, rather than update a record in place, remove
-   * it and add a new record to front of list. This should be better
-   * for performance, too, since we expect to get a burst of
-   * notifications from all neighbors, so put record at front of list. 
-   */
-  if(!SINCMP(sin, &Config.Sockaddr.http->s)){
-    return;
-  }
-  oldCopy = nodeFind(sin);
-  if (oldCopy != NULL){
-    if(oldCopy->timestamp_ns > joinTimeNS){
-      /* We got a stale message; ignore it */
-      return;
+    HierNodeElem *h, *oldCopy;
+    int oldHops;
+    int foundOldJoin = 0;
+    int joinIsNewer;
+
+    assert(sin);
+    /* Ignore if it's already on list and either (1) a newer record
+     * or (2) a current record and at least as close as this
+     * update.  Also ignore if it is me!
+     * For simplicity, rather than update a record in place, remove
+     * it and add a new record to front of list. This should be better
+     * for performance, too, since we expect to get a burst of
+     * notifications from all neighbors, so put record at front of list. 
+     */
+    if (!SINCMP(sin, &Config.Sockaddr.http->s)) {
+	return;
     }
-    else if(oldCopy->action != HC_Join && oldCopy->timestamp_ns < joinTimeNS){
-      /* Join supercedes an old HC_Leave */
-      List_Remove((List_Links *)oldCopy);
-      free(oldCopy);
-      /* Fall through and add this join to nodelist */
+    oldCopy = nodeFind(sin);
+    if (oldCopy != NULL) {
+	if (oldCopy->timestamp_ns > joinTimeNS) {
+	    /* We got a stale message; ignore it */
+	    return;
+	} else if (oldCopy->action != HC_Join
+	    && oldCopy->timestamp_ns < joinTimeNS) {
+	    /* Join supercedes an old HC_Leave */
+	    dlinkDelete(&oldCopy->links, &nodes);
+	    xfree(oldCopy);
+	    /* Fall through and add this join to nodelist */
+	} else {
+	    assert(oldCopy->action == HC_Join);
+	    foundOldJoin = 1;
+	    assert(oldCopy->timestamp_ns <= joinTimeNS);
+	    joinIsNewer = (oldCopy->timestamp_ns < joinTimeNS);
+	    oldHops = netdbHintHops(sin->sin_addr);
+
+
+	    if (oldHops > hops) {
+	        dlinkDelete(&oldCopy->links, &nodes);
+		xfree(oldCopy);
+		/* Fall through and add this join to nodelist and flood */
+	    } else if (joinIsNewer) {
+		/*
+		 * Join is newer but not closer. Propagate to neighbors
+		 * but no need to do anything locally beyond updating
+		 * the timestamp.
+		 */
+		oldCopy->timestamp_ns = joinTimeNS;
+		floodEvent(HC_Join, sin, joinTimeNS, hops + 1);
+		return;
+	    }
+	}
     }
-    else{
-      assert(oldCopy->action == HC_Join); 
-      foundOldJoin = 1;
-      assert(oldCopy->timestamp_ns <= joinTimeNS);
-      joinIsNewer = (oldCopy->timestamp_ns < joinTimeNS);
-      oldHops = netdbHintHops(sin->sin_addr);
+    /*
+     * Only get here if new join supercedes and old join removed or
+     * nonexistant. Do the join and flood it to neighbors.
+     */
+    assert(!nodeFind(sin));
 
+    h = (HierNodeElem *) xmalloc(sizeof(HierNodeElem));
+    HierNodeElem_Init(h, sin, HC_Join, joinTimeNS);
+    dlinkAdd(h, &h->links, &nodes);
 
-      if (oldHops > hops) {
-        List_Remove((List_Links *)oldCopy);
-        free(oldCopy);
-	/* Fall through and add this join to nodelist and flood */
-      }
-      else if(joinIsNewer){
-	/*
-	 * Join is newer but not closer. Propagate to neighbors
-	 * but no need to do anything locally beyond updating
-	 * the timestamp.
-	 */
-        oldCopy->timestamp_ns = joinTimeNS;
-        floodEvent(HC_Join, sin, joinTimeNS, hops+1);
-        return;
-      }
+    /*
+     * Now tell everyone else (locally and network) about 
+     * the new addition or new distance
+     */
+    floodEvent(HC_Join, sin, joinTimeNS, hops + 1);
+    if (foundOldJoin) {
+	HintCacheNodelistOutcallHops(sin, hops, joinTimeNS);
+    } else {
+	hintCacheNodelistOutcallJoin(sin, hops, joinTimeNS);
+    }
+
+    if (!foundOldJoin) {
+	debug(HCNODES_DEBUG, 2)
+	    ("hintCacheNodelist::NetJoin() adds %d.%d.%d.%d; list is: \n",
+	    (unsigned char) ((sin->sin_addr.s_addr & 0xFF000000) >> 24),
+	    (unsigned char) ((sin->sin_addr.s_addr & 0x00FF0000) >> 16),
+	    (unsigned char) ((sin->sin_addr.s_addr & 0x0000FF00) >> 8),
+	    (unsigned char) ((sin->sin_addr.s_addr & 0x000000FF) >> 0));
+	printList();
+	debug(HCNODES_DEBUG, 2) ("\n");
     }
-  }
-  /*
-   * Only get here if new join supercedes and old join removed or
-   * nonexistant. Do the join and flood it to neighbors.
-   */
-  assert(!nodeFind(sin));
-
-  h = (HierNodeElem *)xmalloc(sizeof(HierNodeElem));
-  HierNodeElem_Init(h, sin, HC_Join, joinTimeNS);
-  List_Insert((List_Links *)h, &nodes);
-
-  /*
-   * Now tell everyone else (locally and network) about 
-   * the new addition or new distance
-   */
-  floodEvent(HC_Join, sin, joinTimeNS, hops+1);
-  if(foundOldJoin){
-    HCNodelist_OutcallHops(sin, hops, joinTimeNS);
-  }
-  else{
-    HCNodelist_OutcallJoin(sin, hops, joinTimeNS);
-  }
-
-  if(!foundOldJoin){
-    debug(60, 2, "HCNodelist::NetJoin() adds %d.%d.%d.%d; list is: \n",
-           (unsigned char)((sin->sin_addr.s_addr & 0xFF000000) >> 24),
-           (unsigned char)((sin->sin_addr.s_addr & 0x00FF0000) >> 16),
-           (unsigned char)((sin->sin_addr.s_addr & 0x0000FF00) >> 8),
-           (unsigned char)((sin->sin_addr.s_addr & 0x000000FF) >> 0));
-    printList();
-    debug(60, 2, "\n");
-  }
 
 }
 
 /*
  *------------------------------------------------------------------
  *
- * HCNodelist_NetLeave --
+ * hintCacheNodelistNetLeave --
  *
  *          Process a notification that a node has left the system
  *
@@ -410,72 +413,71 @@
  *
  *----------------------------------------------------7.19.1998--------------
  */
-void 
-HCNodelist_NetLeave (struct sockaddr_in *sin, int hops, 
-                     long long leaveTimeNS)
-{
-  HierNodeElem *h, *oldCopy;
-  int foundOldLeave = 0;
-
-  assert(sin);
-
-  /* Ignore if it's already on list and a newer record.
-   * For simplicity, rather than update a record in place, remove
-   * it and add a new record to front of list. This should be better
-   * for performance, too, since we expect to get a burst of
-   * notifications from all neighbors, so put record at front of list. 
-   */
-  oldCopy = nodeFind(sin);
-  if (oldCopy){
-    if(oldCopy->action == HC_Leave){
-      foundOldLeave = 1;
+void
+hintCacheNodelistNetLeave(struct sockaddr_in *sin, int hops, long long leaveTimeNS)
+{
+    HierNodeElem *h, *oldCopy;
+    int foundOldLeave = 0;
+
+    assert(sin);
+
+    /* Ignore if it's already on list and a newer record.
+     * For simplicity, rather than update a record in place, remove
+     * it and add a new record to front of list. This should be better
+     * for performance, too, since we expect to get a burst of
+     * notifications from all neighbors, so put record at front of list. 
+     */
+    oldCopy = nodeFind(sin);
+    if (oldCopy) {
+	if (oldCopy->action == HC_Leave) {
+	    foundOldLeave = 1;
+	}
+	if (oldCopy->timestamp_ns < leaveTimeNS) {
+	    dlinkDelete(&oldCopy->links, &nodes);
+	    xfree(oldCopy);
+	} else {
+	    /* 
+	     * old copy is actually newer than this update. Ignore this
+	     * update.
+	     */
+	    return;
+	}
     }
-    if(oldCopy->timestamp_ns < leaveTimeNS){
-      List_Remove((List_Links *)oldCopy);
-      free(oldCopy);
+    /*
+     * Only get here if new leave supercedes old record removed or
+     * nonexistant 
+     */
+    assert(!nodeFind(sin));
+
+    h = (HierNodeElem *) xmalloc(sizeof(HierNodeElem));
+    HierNodeElem_Init(h, sin, HC_Leave, leaveTimeNS);
+    dlinkAdd(h, &h->links, &nodes);
+
+    /*
+     * Now tell everyone else (locally and network) about 
+     * the new addition or new distance
+     */
+    floodEvent(HC_Leave, sin, leaveTimeNS, hops + 1);
+    if (!foundOldLeave) {
+	HCNodelist_OutcallLeave(sin, hops, leaveTimeNS);
     }
-    else{
-      /* 
-       * old copy is actually newer than this update. Ignore this
-       * update.
-       */
-      return;
+
+    if (!foundOldLeave) {
+	debug(HCNODES_DEBUG, 4)
+	    ("HCNodelist::NetLeave() removes %d.%d.%d.%d; list is: \n",
+	    (unsigned char) ((sin->sin_addr.s_addr & 0xFF000000) >> 24),
+	    (unsigned char) ((sin->sin_addr.s_addr & 0x00FF0000) >> 16),
+	    (unsigned char) ((sin->sin_addr.s_addr & 0x0000FF00) >> 8),
+	    (unsigned char) ((sin->sin_addr.s_addr & 0x000000FF) >> 0));
+	printList();
+	debug(HCNODES_DEBUG, 4) ("\n");
     }
-  }
-  /*
-   * Only get here if new leave supercedes old record removed or
-   * nonexistant 
-   */
-  assert(!nodeFind(sin));
-
-  h = (HierNodeElem *)xmalloc(sizeof(HierNodeElem));
-  HierNodeElem_Init(h, sin, HC_Leave, leaveTimeNS);
-  List_Insert((List_Links *)h, &nodes);
-
-  /*
-   * Now tell everyone else (locally and network) about 
-   * the new addition or new distance
-   */
-  floodEvent(HC_Leave, sin, leaveTimeNS, hops+1);
-  if(!foundOldLeave){
-    HCNodelist_OutcallLeave(sin, hops, leaveTimeNS);
-  }
-  
-  if(!foundOldLeave){
-    debug(60, 2, "HCNodelist::NetLeave() removes %d.%d.%d.%d; list is: \n",
-           (unsigned char)((sin->sin_addr.s_addr & 0xFF000000) >> 24),
-           (unsigned char)((sin->sin_addr.s_addr & 0x00FF0000) >> 16),
-           (unsigned char)((sin->sin_addr.s_addr & 0x0000FF00) >> 8),
-           (unsigned char)((sin->sin_addr.s_addr & 0x000000FF) >> 0));
-    printList();
-    debug(60, 2, "\n");
-  }
 }
 
 /*
  *------------------------------------------------------------------
  *
- * HCNodelist_OutcallHops --
+ * hintCacheNodelist_OutcallHops --
  *
  *          This function gets called whenever the number of hops
  *          to a node *changes* due to network updates. This
@@ -496,30 +498,30 @@
  *
  *--------------------------------------------------------7.19.1998-----
  */
-static void 
-HCNodelist_OutcallHops(struct sockaddr_in *sin, int hops, long long timeNS)
+static void
+hintCacheNodelistOutcallHops(struct sockaddr_in *sin, int hops, long long timeNS)
 {
-  char name[16];
+    char name[16];
 
-  /*
-   * Tell netdb
-   */
-  strcpy(name, inet_ntoa(sin->sin_addr));
-  if(!netdbHintHops(sin->sin_addr)){
-    netdbAdd(sin->sin_addr, name);
-  }
-  netdbUpdateHintHops(sin->sin_addr, hops);
+    /*
+     * Tell netdb
+     */
+    strcpy(name, inet_ntoa(sin->sin_addr));
+    if (!netdbHintHops(sin->sin_addr)) {
+	netdbAdd(sin->sin_addr, name);
+    }
+    netdbUpdateHintHops(sin->sin_addr, hops);
 
-  /* 
-   * Tell plaxton algorithm
-   */
-  HCPlax_changeDistance(sin);
-} 
+    /* 
+     * Tell plaxton algorithm
+     */
+    hintCachePlax_changeDistance(sin);
+}
 
 /*
  *------------------------------------------------------------------
  *
- * HCNodelist_OutcallJoin --
+ * hintCacheNodelistOutcallJoin --
  *
  *          This function gets called whenever a node joins the
  *          sytsem.
@@ -541,28 +543,28 @@
  *
  *-------------------------------------------------7.19.1998-----------
  */
-static void 
-HCNodelist_OutcallJoin(struct sockaddr_in *sin, int hops, long long timeNS)
+static void
+hintCacheNodelistOutcallJoin(struct sockaddr_in *sin, int hops, long long timeNS)
 {
-  char name[16];
+    char name[16];
 
-  /*
-   * Tell netdb
-   */
-  strcpy(name, inet_ntoa(sin->sin_addr));
-  netdbAdd(sin->sin_addr, name);
-  netdbUpdateHintHops(sin->sin_addr, hops);
-
-  /* 
-   * Tell plaxton algorithm
-   */
-  HCPlax_addNode(sin);
+    /*
+     * Tell netdb
+     */
+    strcpy(name, inet_ntoa(sin->sin_addr));
+    netdbAdd(sin->sin_addr, name);
+    netdbUpdateHintHops(sin->sin_addr, hops);
+
+    /* 
+     * Tell plaxton algorithm
+     */
+    hintCachePlax_addNode(sin);
 }
 
 /*
  *------------------------------------------------------------------
  *
- * HCNodelist_OutcallLeave --
+ * hintCacheNodelistOutcallLeave --
  *
  *          This function gets called whenever a node leaves the
  *          sytsem.
@@ -582,13 +584,13 @@
  *
  *-----------------------------------------------------7.19.1998----------
  */
-static void 
-HCNodelist_OutcallLeave(struct sockaddr_in *sin, int hops, long long timeNS)
+static void
+hintCacheNodelistOutcallLeave(struct sockaddr_in *sin, int hops, long long timeNS)
 {
-  /* 
-   * Tell plaxton algorithm
-   */
-  HCPlax_removeNode(sin);
+    /* 
+     * Tell plaxton algorithm
+     */
+    hintCachePlax_removeNode(sin);
 }
 
 
@@ -613,16 +615,16 @@
 static HierNodeElem *
 nodeFind(struct sockaddr_in *sin)
 {
-  HierNodeElem *e;
-  List_Links *item;
+    HierNodeElem *e;
+    dlink_node *item;
 
-  LIST_FORALL(&nodes, item) {
-    e = (HierNodeElem *) item;
-    if (!SINCMP(&e->sin, sin)){
-      return(e);
+    for (item = nodes.head; item; item = item->next) {
+	e = (HierNodeElem *) item;
+	if (!SINCMP(&e->sin, sin)) {
+	    return (e);
+	}
     }
-  }
-  return(NULL);
+    return (NULL);
 }
 
 /*
@@ -648,166 +650,58 @@
  *-------------------------------------------------3.31.1998--------
  */
 static void
-floodEvent(int action, struct sockaddr_in *source, long long timeNS, 
-	   int hopcount)
+floodEvent(int action, struct sockaddr_in *source, long long timeNS,
+    int hopcount)
 {
 #ifdef USE_DYNAMIC_HIERARCHY
-  HCEntry entry;
-  peer *p;
-  URLKey hackURLKey;
-  struct sockaddr_in dest;
+    HintCacheEntry entry;
+    peer *p;
+    URLKey hackURLKey;
+    struct sockaddr_in dest;
 
-  assert(action == HC_Join || action == HC_Leave);
+    assert(action == HC_Join || action == HC_Leave);
 
-  if(neighborsOutgoing == NULL){
-    return;
-  }
+    if (neighborsOutgoing == NULL) {
+	return;
+    }
 
-  hackURLKey.key = timeNS; /* XXX Update should be a union XXX */
+    hackURLKey.key = timeNS;	/* XXX Update should be a union XXX */
 
-  HCEntry_Init(&entry, hackURLKey, source);
-  HCNet_Enqueue(neighborsOutgoing, action, &entry, hopcount);
+    hintCacheEntry_Init(&entry, hackURLKey, source);
+    hintCacheNet_Enqueue(neighborsOutgoing, action, &entry, hopcount);
 #if 1
-  HCNet_Complete(neighborsOutgoing);
+    hintCacheNet_Complete(neighborsOutgoing);
 
-  for (p = getFirstPeer(); p; p = getNextPeer(p)) {
-    if(p->in_addr.sin_addr.s_addr == 0){
-      debug(60, 4, "HCNodelist warning: peer %s addr not set\n",
-	    p->host);
-      continue;
+    for (p = getFirstPeer(); p; p = getNextPeer(p)) {
+	if (p->in_addr.sin_addr.s_addr == 0) {
+	    debug(HCNODES_DEBUG, 4)
+		("hintCacheNodelist warning: peer %s addr not set\n", p->host);
+	    continue;
+	}
+	dest.sin_family = AF_INET;
+	dest.sin_addr = p->in_addr.sin_addr;
+	dest.sin_port = p->http_port;
+	hintCacheNet_SendTo(neighborsOutgoing, &dest);
     }
-    dest.sin_family = AF_INET;
-    dest.sin_addr = p->in_addr.sin_addr;
-    dest.sin_port = p->http_port;
-    HCNet_SendTo(neighborsOutgoing, &dest);
-  }
 
-  HCNet_Done(neighborsOutgoing);
+    hintCacheNet_Done(neighborsOutgoing);
 #endif
 #endif /* USE_DYNAMIC_HIERARCHY */
 }
 
 
-/*
- *------------------------------------------------------------------
- * MDD 7.18.1998
- * HCNodelist_addMembershipNeighbor --
- *
- *          Add a node to the peerlist to which to flood
- *          events (if node not already on that list).
- *
- * Arguments:
- *      None.
- *
- * Results:
- *      None.
- *
- * Side effects:
- *      None.
- *
- *---------------------------------------------------7.18.1998----------
- */
-void
-HCNodelist_addMembershipNeighbor(struct sockaddr_in *neighbor)
-{
-  char name[16];
-  peer *p;
-
-  sprintf(name, inet_ntoa(neighbor->sin_addr));
-  for (p = getFirstPeer(); p; p = getNextPeer(p)) {
-    if(p->in_addr.sin_addr.s_addr == neighbor->sin_addr.s_addr
-       || !strcmp(p->host, name)){
-      return;
-    }
-  }
-  debug(60, 2, "Nodelist_addMembership...: letting through %s (%s)\n",
-	p->host, inet_ntoa(p->in_addr.sin_addr));
-  
-  neighborAdd(name, 
-              "", /* const char *type */
-              neighbor->sin_port,
-              3130  /* XXX, though ICP is irrelevant in hint world */, 
-              0, /* options ??? */
-              1, /* weight */
-              1 /* mcast_ttl ?? */);
-
-  /*
-   * Now lookup the ip address for this peer (the peerlist ip
-   * addresses get refreshed at the beginning of time
-   * and then once per hour. We don't want to wait that
-   * long.
-   */
-  for (p = getFirstPeer(); p; p = getNextPeer(p)) {
-    if(!strcmp(p->host, name)){
-      if(p->in_addr.sin_addr.s_addr == 0){
-        p->ip_lookup_pending = 1;
-        /* some random, bogus FD for ipcache */
-        p->ipcache_fd = Squid_MaxFD + current_time.tv_usec;
-        ipcache_nbgethostbyname(p->host, p->ipcache_fd, peerDNSConfigure, p);
-        return;
-      }
-    }
-  }
-  /*
-   * Should not get here. If neighbor on list, returned early.
-   * If we added neighbor, we should find it on peer list with
-   * no IP address yet and we returned after starting the 
-   * gethostbyname() call.
-   */
-  assert(0);
-  return;
-      
-}
-
-
-
-/*
- *------------------------------------------------------------------
- * MDD 7.18.1998
- * HCNodelist_removeMembershipNeighbor --
- *
- *          Remove a node to the peerlist to which to flood
- *          events.
- *
- * Arguments:
- *      None.
- *
- * Results:
- *      None.
- *
- * Side effects:
- *      None.
- *
- *---------------------------------------------------7.18.1998----------
- */
-void HCNodelist_rmMembershipNeighbor(struct sockaddr_in *neighbor)
-{
-  peer *p;
-  for (p = getFirstPeer(); p; p = getNextPeer(p)) {
-    if(p->in_addr.sin_addr.s_addr == neighbor->sin_addr.s_addr){
-      /*
-       * XXX neighborRemove() is static so can't actually do this.
-       * Benign bug.
-       */
-      /* neighborRemove(p); XXX */
-      debug(60, 10, "HCnodelist_rmMembershipNeighbor not yet implemented\n");
-    }
-  }
-}
-
-
 
 /*
  *------------------------------------------------------------------
  *
- * HCNodeList_IterXXX --
+ * hintCacheNodeListIterXXX --
  *
  *          Used for iterating through all addresses on list.
  *
- *   for(HCNodeList_IterStart(&iter);
- *       HCNodeList_IterCheck(&iter);
- *       HCNodeList_IterNext(&iter)){
- *     valid = HCNOdeList_IterGetAddr(&iter, &addr);
+ *   for(hintCacheNodeListIterStart(&iter);
+ *       hintCacheNodeListIterCheck(&iter);
+ *       hintCacheNodeListIterNext(&iter)){
+ *     valid = hintCacheNOdeListIterGetAddr(&iter, &addr);
  *   }
  *  
  * Arguments:
@@ -826,47 +720,48 @@
  *
  *------------------------------------------------------------------
  */
-void 
-HCNodeList_IterStart(HCNLIter *iter)
+void
+hintCacheNodeListIterStart(HintCacheNodeListIter iter)
 {
-  *iter = (HCNLIter)List_First(&nodes);
+    iter = (HintCacheNodeListIter) nodes.head;
 }
 
 int
-HCNodeList_IterCheck(HCNLIter iter)
+hintCacheNodeList_IterCheck(HintCacheNodeListIter iter)
 {
-  return(!List_IsAtEnd(&nodes, iter));
+    dlink_node *links = iter;
+    return (links->next != 0);
 }
 
-void 
-HCNodeList_IterNext(HCNLIter *iter)
+void
+hintCacheNodeList_IterNext(HintCacheNodeListIter iter)
 {
-  HierNodeElem *elem;
+    HierNodeElem *elem;
 
-  if(List_IsAtEnd(&nodes, *iter)){
-    return;
-  }
-
-  while(1){
-    *iter = (HCNLIter)List_Next(*iter);
-    /*
-     * Skip non-HC_Join elements by keeping going in that case.
-     */
-    if(List_IsAtEnd(&nodes, *iter)){
-      return;
+    if (iter->next == 0) {
+	return;
     }
-    elem = (HierNodeElem *)*iter;
-    if(elem->action == HC_Join){
-      return;
+
+    while (1) {
+	iter = iter->next;
+	/*
+	 * Skip non-HC_Join elements by keeping going in that case.
+	 */
+	if (iter->next == 0) {
+	    return;
+	}
+	elem = iter->data;
+	if (elem->action == HC_Join) {
+	    return;
+	}
     }
-  }
-    
+
 }
 
 /*
  *------------------------------------------------------------------
  *
- * HCNodeList_IterGetAddr --
+ * hintCacheNodelistIterGetAddr --
  *
  *          description.
  *
@@ -882,15 +777,15 @@
  *------------------------------------------------------------------
  */
 int
-HCNodeList_IterGetAddr(HCNLIter iter, struct sockaddr_in *ret)
+hintCacheNodelistIterGetAddr(HintCacheNodeListIter iter, struct sockaddr_in *ret)
 {
-  HierNodeElem *elem;
-  elem = (HierNodeElem *)iter;
-  *ret = elem->sin;
-  if(elem->action == HC_Join){
-    return 1;
-  }
-  return 0;
+    HierNodeElem *elem;
+    elem = iter->data;
+    *ret = elem->sin;
+    if (elem->action == HC_Join) {
+	return 1;
+    }
+    return 0;
 }
 
 
@@ -915,17 +810,17 @@
 static long long
 currentTimeNS()
 {
-  static const long long NS_PER_SEC = 1000000000;
-  static const long long NS_PER_USEC = 1000;
-  int error;
-  struct timeval time;
-  long long ret;
-
-  error = gettimeofday(&time, NULL);
-  assert(error != -1);
-  ret = NS_PER_SEC * (long long)time.tv_sec 
-    + NS_PER_USEC * (long long)time.tv_usec;
-  return ret;
+    static const long long NS_PER_SEC = 1000000000;
+    static const long long NS_PER_USEC = 1000;
+    int error;
+    struct timeval time;
+    long long ret;
+
+    error = gettimeofday(&time, NULL);
+    assert(error != -1);
+    ret = NS_PER_SEC * (long long) time.tv_sec
+	+ NS_PER_USEC * (long long) time.tv_usec;
+    return ret;
 }
 
 /*
@@ -950,22 +845,22 @@
 static void
 printList()
 {
-  HCNLIter iter;
-  struct sockaddr_in nodeAddr;
-  int valid;
-
-  for(HCNodeList_IterStart(&iter);
-      HCNodeList_IterCheck(iter);
-      HCNodeList_IterNext(&iter)){
-    valid = HCNodeList_IterGetAddr(iter, &nodeAddr);
-    if(valid){
-      debug(60, 2, "\t%d.%d.%d.%d\n",
-             (unsigned char)((nodeAddr.sin_addr.s_addr & 0xFF000000) >> 24),
-             (unsigned char)((nodeAddr.sin_addr.s_addr & 0x00FF0000) >> 16),
-             (unsigned char)((nodeAddr.sin_addr.s_addr & 0x0000FF00) >> 8),
-             (unsigned char)((nodeAddr.sin_addr.s_addr & 0x000000FF) >> 0));
+    HintCacheNodeListIter iter;
+    struct sockaddr_in nodeAddr;
+    int valid;
+
+    for (hintCacheNodeListIterStart(iter);
+	hintCacheNodeListIterCheck(iter); hintCacheNodeListIterNext(&iter)) {
+	valid = hintCacheNodeListIterGetAddr(iter, &nodeAddr);
+	if (valid) {
+	    debug(HCNODES_DEBUG, 2)
+		("\t%d.%d.%d.%d\n",
+		(unsigned char) ((nodeAddr.sin_addr.s_addr & 0xFF000000) >> 24),
+		(unsigned char) ((nodeAddr.sin_addr.s_addr & 0x00FF0000) >> 16),
+		(unsigned char) ((nodeAddr.sin_addr.s_addr & 0x0000FF00) >> 8),
+		(unsigned char) ((nodeAddr.sin_addr.s_addr & 0x000000FF) >> 0));
+	}
     }
-  }
 }
 
 
@@ -973,7 +868,7 @@
 /*
  *------------------------------------------------------------------
  *
- * HCNodelist_SelfTest --
+ * hintCacheNodelistSelfTest --
  *
  *          description.
  *
